//@author: vux
//@help: standard constant shader
//@tags: color
//@credits: 

Texture2D  VTex <string uiname="Velocity";>;

SamplerState g_samLinear : IMMUTABLE
{
    Filter = MIN_MAG_MIP_POINT;
	
    AddressU = Clamp;
    AddressV = Clamp;
};

 
cbuffer cbPerDraw : register( b0 )
{
	float4x4 tVP : VIEWPROJECTION;
};


cbuffer cbPerObj : register( b1 )
{
	float4x4 tW : WORLD;
	float Alpha <float uimin=0.0; float uimax=1.0;> = 1; 
	float4 cAmb <bool color=true;String uiname="Color";> = { 1.0f,1.0f,1.0f,1.0f };
	float4x4 tTex <string uiname="Texture Transform"; bool uvspace=true; >;
	float4x4 tColor <string uiname="Color Transform";>;
};

struct VS_IN
{
	float4 PosO : POSITION;
	float4 TexCd : TEXCOORD0;

};

struct vs2ps
{
    float4 PosWVP: SV_POSITION;
    float4 TexCd: TEXCOORD0;
};

vs2ps VS(VS_IN input)
{
    vs2ps Out = (vs2ps)0;
    Out.PosWVP  = mul(input.PosO,mul(tW,tVP));
    Out.TexCd =  mul(input.TexCd, tTex);
    return Out;
}



float vFlowDims;


float4 PS(vs2ps In): SV_Target
{
   float4 vL = VTex.Sample(g_samLinear, float2(In.TexCd.x - 1./vFlowDims, In.TexCd.y)); 
   float4 vR = VTex.Sample(g_samLinear, float2(In.TexCd.x + 1./vFlowDims, In.TexCd.y)); 
   float4 vB = VTex.Sample(g_samLinear, float2(In.TexCd.x, In.TexCd.y - 1./vFlowDims)); 
   float4 vT = VTex.Sample(g_samLinear, float2(In.TexCd.x, In.TexCd.y + 1./vFlowDims)); 
   return 0.5 * ((vR.x - vL.x) + (vT.y - vB.y));
}





technique10 Constant
{
	pass P0
	{
		SetVertexShader( CompileShader( vs_4_0, VS() ) );
		SetPixelShader( CompileShader( ps_4_0, PS() ) );
		//alphablendenable = false;    
	}
}




